#include <vector>
#include <iostream>

struct INS_SOL_RESULT_ANGLE_Signals {
    double ins_course_angle;
    double ins_yaw_angle;
    double ins_pitch;
    double ins_roll;
    long timestamp_s;
    long timestamp_ns;
    int crc8;
};

struct INS_SOL_RESULT_ALTITUDE_Signals {
    double ins_altitude;
    double ins_altitude_std;
    double ins_undulation;
    long timestamp_s;
    long timestamp_ns;
    int crc8;
};

struct INS_SOL_RESULT_LONGITUDE_Signals {
    double ins_longitude;
    double ins_longitude_std;
    long timestamp_s;
    long timestamp_ns;
    int crc8;
};

struct INS_SOL_RESULT_LATITUDE_Signals {
    double ins_latitude;
    double ins_latitude_std;
    long timestamp_s;
    long timestamp_ns;
    int crc8;
};

struct INS_SOL_RESULT_COMMON_Signals {
    int ins_gps_week;
    int ins_gps_sow; // Second of week
    long timestamp_s;
    long timestamp_ns;
    int crc8;
};

struct CAN2SWC {
    long long time; // Time from %time column
    /*VCU_Info_1_Signals vcu_info_1_signals;
    VCU_Info_2_Signals vcu_info_2_signals;
    DEVSTATUS_Signals devstatus_signals;
    HEADING_ANGLE_Signals heading_angle_signals;
    INS_SOL_RESULT_STATUS_Signals ins_sol_result_status_signals;
    INS_SOL_RESULT_VEL_STD_Signals ins_sol_result_vel_std_signals;
    INS_SOL_RESULT_VEL_Signals ins_sol_result_vel_signals;
    INS_SOL_RESULT_ANGLE_STD_Signals ins_sol_result_angle_std_signals;*/
    INS_SOL_RESULT_ANGLE_Signals ins_sol_result_angle_signals;
    INS_SOL_RESULT_ALTITUDE_Signals ins_sol_result_altitude_signals;
    INS_SOL_RESULT_LONGITUDE_Signals ins_sol_result_longitude_signals;
    INS_SOL_RESULT_LATITUDE_Signals ins_sol_result_latitude_signals;
    INS_SOL_RESULT_COMMON_Signals ins_sol_result_common_signals;
};

std::vector<CAN2SWC> can_data;
